From 2dd4e037a2d7eebb4491cb76f87da3197814f8c3 Mon Sep 17 00:00:00 2001
From: Daniel Mierswa <impulze@impulze.org>
Date: Sat, 30 Jan 2010 18:51:07 +0100
Subject: [PATCH 06/10] Put mmx/sse/etc. optimizations handling into separate file.

Also don't globably substitute MMX/SSE/etc. _CFLAGS but put them into
the modules that need 'em.

Signed-off-by: Daniel Mierswa <impulze@impulze.org>
---
 configure.ac                |  359 ++++++-------------------------------------
 m4/vlc_optimizations.m4     |  356 ++++++++++++++++++++++++++++++++++++++++++
 modules/arm_neon/Modules.am |    2 -
 modules/mmx/Modules.am      |    2 -
 modules/sse2/Modules.am     |    2 -
 5 files changed, 406 insertions(+), 315 deletions(-)
 create mode 100644 m4/vlc_optimizations.m4

diff --git a/configure.ac b/configure.ac
index 6368eed..e3e89a9 100644
--- a/configure.ac
+++ b/configure.ac
@@ -942,18 +942,6 @@ if test "${ac_cv_c_attribute_packed}" != "no"; then
   AC_DEFINE(HAVE_ATTRIBUTE_PACKED, 1, Support for __attribute__((packed)) for structs)
 fi
 
-dnl
-dnl  Check the CPU
-dnl
-case "${host_cpu}" in
-  "")
-    ARCH=unknown
-    ;;
-  *)
-    ARCH="${host_cpu}"
-    ;;
-esac
-
 dnl Check for backtrace() support
 AC_CHECK_HEADERS(execinfo.h)
 AC_CHECK_FUNCS(backtrace)
@@ -998,322 +986,75 @@ dnl
 EXTEND_HELP_STRING([])
 EXTEND_HELP_STRING([Optimization options:])
 
-dnl  Check for fully working MMX intrinsics
-dnl  We need support for -mmmx, we need <mmintrin.h>, and we also need a
-dnl  working compiler (http://gcc.gnu.org/bugzilla/show_bug.cgi?id=23963)
-AS_CASE(
-  ["${host_cpu}"],
-  [i?86|x86_64], [VLC_FEATURE_DEFAULT_ENABLE([mmx])],
-  [VLC_FEATURE_DEFAULT_DISABLE([mmx])]
+dnl SSE/SSE2 won't work on solaris
+AS_CASE(["${SYS}"],
+  [solaris], [ac_cv_sse_inline="no" ; ac_cv_sse2_inline="no"]
 )
-VLC_FEATURE_OPTION([mmx], [enable MMX optimizations], [auto])
-have_mmx="no"
-have_mmxext="no"
-AS_IF([VLC_FEATURE_ENABLED([mmx])], [
-  ARCH="${ARCH} mmx"
-
-  AC_CACHE_CHECK([if $CC groks MMX intrinsics],
-    [ac_cv_c_mmx_intrinsics],
-    [CFLAGS="${CFLAGS_save} -O -mmmx"
-     AC_TRY_COMPILE([#include <mmintrin.h>
-                     #include <stdint.h>
-                     uint64_t frobzor;],
-                    [__m64 a, b, c;
-                     a = b = c = (__m64)frobzor;
-                     a = _mm_slli_pi16(a, 3);
-                     a = _mm_adds_pi16(a, b);
-                     c = _mm_srli_pi16(c, 8);
-                     c = _mm_slli_pi16(c, 3);
-                     b = _mm_adds_pi16(b, c);
-                     a = _mm_unpacklo_pi8(a, b);
-                     frobzor = (uint64_t)a;],
-                    [ac_cv_c_mmx_intrinsics=yes],
-                    [ac_cv_c_mmx_intrinsics=no])])
-  AS_IF([test "${ac_cv_c_mmx_intrinsics}" != "no"], [
-    AC_DEFINE(HAVE_MMX_INTRINSICS, 1,
-              [Define to 1 if MMX intrinsics are available.])
-    MMX_CFLAGS="-mmmx"
-  ])
 
-  AC_CACHE_CHECK([if $CC groks MMX inline assembly],
-    [ac_cv_mmx_inline],
-    [CFLAGS="${CFLAGS_save}"
-     AC_TRY_COMPILE(,[void *p;asm volatile("packuswb %%mm1,%%mm2"::"r"(p));],
-                    ac_cv_mmx_inline=yes, ac_cv_mmx_inline=no)])
-  AS_IF([test "${ac_cv_mmx_inline}" != "no"], [
-    AC_DEFINE(CAN_COMPILE_MMX, 1,
-              [Define to 1 inline MMX assembly is available.])
-    have_mmx="yes"
-  ])
+VLC_FEATURE_DEFAULT_DISABLE([altivec mmx neon sse])
 
-  AC_CACHE_CHECK([if $CC groks MMX EXT inline assembly],
-    [ac_cv_mmxext_inline],
-    [CFLAGS="${CFLAGS_save}"
-     AC_TRY_COMPILE(,[void *p;asm volatile("maskmovq %%mm1,%%mm2"::"r"(p));],
-                    ac_cv_mmxext_inline=yes, ac_cv_mmxext_inline=no)])
-  AS_IF([test "${ac_cv_mmxext_inline}" != "no"], [
-    AC_DEFINE(CAN_COMPILE_MMXEXT, 1,
-              [Define to 1 if MMX EXT inline assembly is available.])
-    have_mmxext="yes"
-  ])
-])
-AC_SUBST(MMX_CFLAGS)
-AM_CONDITIONAL([HAVE_MMX], [test "${have_mmx}" = "yes"])
-AM_CONDITIONAL([HAVE_MMXEXT], [test "${have_mmxext}" = "yes"])
-
-dnl  Check for fully workin SSE2 intrinsics
-dnl  We need support for -mmmx, we need <emmintrin.h>, and we also need a
-dnl  working compiler (http://gcc.gnu.org/bugzilla/show_bug.cgi?id=23963)
-AS_CASE(
-  ["${host_cpu}"],
-  [i686|x86_64], [VLC_FEATURE_DEFAULT_ENABLE([sse])],
-  [VLC_FEATURE_DEFAULT_DISABLE([sse])]
+dnl Enable optimization based on CPU
+AS_CASE(["${host_cpu}"],
+  [powerpc], [VLC_FEATURE_DEFAULT_ENABLE([altivec])],
+  [arm], [VLC_FEATURE_DEFAULT_ENABLE([neon])],
+  [i686|x86_64], [VLC_FEATURE_DEFAULT_ENABLE([mmx sse])],
+  [i?86], [VLC_FEATURE_DEFAULT_ENABLE([mmx])]
 )
-VLC_FEATURE_OPTION([sse], [enable SSE (1, 2, 3 and 4) optimizations], [auto])
-have_sse2="no"
-AS_IF([VLC_FEATURE_ENABLED([sse])], [
-  ARCH="${ARCH} sse sse2"
-
-  AC_CACHE_CHECK([if $CC groks SSE2 intrinsics],
-    [ac_cv_c_sse2_intrinsics],
-    [CFLAGS="${CFLAGS_save} -O -msse2"
-     AC_TRY_COMPILE([#include <emmintrin.h>
-                     #include <stdint.h>
-                     uint64_t frobzor;],
-                    [__m128i a, b, c;
-                     a = b = c = _mm_set1_epi64((__m64)frobzor);
-                     a = _mm_slli_epi16(a, 3);
-                     a = _mm_adds_epi16(a, b);
-                     c = _mm_srli_epi16(c, 8);
-                     c = _mm_slli_epi16(c, 3);
-                     b = _mm_adds_epi16(b, c);
-                     a = _mm_unpacklo_epi8(a, b);
-                     frobzor = (uint64_t)_mm_movepi64_pi64(a);],
-                    [ac_cv_c_sse2_intrinsics=yes],
-                    [ac_cv_c_sse2_intrinsics=no])])
-  AS_IF([test "${ac_cv_c_sse2_intrinsics}" != "no"], [
-    AC_DEFINE(HAVE_SSE2_INTRINSICS, 1,
-              [Define to 1 if SSE2 intrinsics are available.])
-    SSE2_CFLAGS="-msse2"
-  ])
 
-  AC_CACHE_CHECK([if $CC groks SSE inline assembly],
-    [ac_cv_sse_inline],
-    [CFLAGS="${CFLAGS_save}"
-     AC_TRY_COMPILE(,[void *p;asm volatile("xorps %%xmm1,%%xmm2"::"r"(p));],
-                    ac_cv_sse_inline=yes, ac_cv_sse_inline=no)])
-  AS_IF([test "${ac_cv_sse_inline}" != "no" -a "${SYS}" != "solaris"], [
-    AC_DEFINE(CAN_COMPILE_SSE, 1,
-              [Define to 1 if SSE inline assembly is available.])
-  ])
+AS_CASE(["${host_cpu}"],
+  [""], [ARCH="unknown"],
+  [ARCH="${host_cpu}"]
+)
 
-  AC_CACHE_CHECK([if $CC groks SSE2 inline assembly],
-    [ac_cv_sse2_inline],
-    [CFLAGS="${CFLAGS_save}"
-     AC_TRY_COMPILE(,[void *p;asm volatile("punpckhqdq %%xmm1,%%xmm2"::"r"(p));],
-                    ac_cv_sse2_inline=yes, ac_cv_sse2_inline=no)])
-  AS_IF([test "${ac_cv_sse2_inline}" != "no" -a "${SYS}" != "solaris"], [
-    AC_DEFINE(CAN_COMPILE_SSE2, 1,
-              [Define to 1 if SSE2 inline assembly is available.])
-    have_sse2="yes"
-  ])
+dnl Set and extend ARCH
+AS_IF([VLC_FEATURE_ENABLED([altivec])], [ARCH="${ARCH} altivec"])
+AS_IF([VLC_FEATURE_ENABLED([mmx])], [ARCH="${ARCH} mmx"])
+AS_IF([VLC_FEATURE_ENABLED([sse])], [ARCH="${ARCH} sse sse2"])
 
-  # SSE3
-  AC_CACHE_CHECK([if $CC groks SSE3 inline assembly],
-    [ac_cv_sse3_inline],
-    [CFLAGS="${CFLAGS_save}"
-     AC_TRY_COMPILE(,[void *p;asm volatile("movsldup %%xmm1,%%xmm0"::"r"(p));],
-                    ac_cv_sse3_inline=yes, ac_cv_sse3_inline=no)])
-  AS_IF([test "${ac_cv_sse3_inline}" != "no"], [
-    AC_DEFINE(CAN_COMPILE_SSE3, 1,
-              [Define to 1 if SSE3 inline assembly is available.]) ])
-  # SSSE3
-  AC_CACHE_CHECK([if $CC groks SSSE3 inline assembly],
-    [ac_cv_ssse3_inline],
-    [CFLAGS="${CFLAGS_save}"
-     AC_TRY_COMPILE(,[void *p;asm volatile("pabsw %%xmm0,%%xmm0"::"r"(p));],
-                    ac_cv_ssse3_inline=yes, ac_cv_ssse3_inline=no)])
-  AS_IF([test "${ac_cv_ssse3_inline}" != "no"], [
-    AC_DEFINE(CAN_COMPILE_SSSE3, 1,
-              [Define to 1 if SSSE3 inline assembly is available.]) ])
-
-  # SSE4.1
-  AC_CACHE_CHECK([if $CC groks SSE4.1 inline assembly],
-    [ac_cv_sse4_1_inline],
-    [CFLAGS="${CFLAGS_save}"
-     AC_TRY_COMPILE(,[void *p;asm volatile("pmaxsb %%xmm1,%%xmm0"::"r"(p));],
-                    ac_cv_sse4_1_inline=yes, ac_cv_sse4_1_inline=no)])
-  AS_IF([test "${ac_cv_sse4_1_inline}" != "no"], [
-    AC_DEFINE(CAN_COMPILE_SSE4_1, 1,
-              [Define to 1 if SSE4_1 inline assembly is available.]) ])
-
-  # SSE4.2
-  AC_CACHE_CHECK([if $CC groks SSE4.2 inline assembly],
-    [ac_cv_sse4_2_inline],
-    [CFLAGS="${CFLAGS_save}"
-     AC_TRY_COMPILE(,[void *p;asm volatile("pcmpgtq %%xmm1,%%xmm0"::"r"(p));],
-                    ac_cv_sse4_2_inline=yes, ac_cv_sse4_2_inline=no)])
-  AS_IF([test "${ac_cv_sse4_2_inline}" != "no"], [
-    AC_DEFINE(CAN_COMPILE_SSE4_2, 1,
-              [Define to 1 if SSE4_2 inline assembly is available.]) ])
-
-  # SSE4A
-  AC_CACHE_CHECK([if $CC groks SSE4A inline assembly],
-    [ac_cv_sse4a_inline],
-    [CFLAGS="${CFLAGS_save}"
-     AC_TRY_COMPILE(,[void *p;asm volatile("insertq %%xmm1,%%xmm0"::"r"(p));],
-                    ac_cv_sse4a_inline=yes, ac_cv_sse4a_inline=no)])
-  AS_IF([test "${ac_cv_sse4a_inline}" != "no"], [
-    AC_DEFINE(CAN_COMPILE_SSE4A, 1,
-              [Define to 1 if SSE4A inline assembly is available.]) ])
-])
-AC_SUBST(SSE2_CFLAGS)
-AM_CONDITIONAL([HAVE_SSE2], [test "$have_sse2" = "yes"])
-
-have_3dnow="no"
-AC_CACHE_CHECK([if $CC groks 3D Now! inline assembly],
-    [ac_cv_3dnow_inline],
-    [CFLAGS="${CFLAGS_save}"
-     AC_TRY_COMPILE(,[void *p;asm volatile("pfadd %%mm1,%%mm2"::"r"(p));],
-                    ac_cv_3dnow_inline=yes, ac_cv_3dnow_inline=no)])
-AS_IF([test "${ac_cv_3dnow_inline}" != "no"], [
-  AC_DEFINE(CAN_COMPILE_3DNOW, 1,
-            [Define to 1 if 3D Now! inline assembly is available.])
-  have_3dnow="yes"
-])
-AM_CONDITIONAL([HAVE_3DNOW], [test "$have_3dnow" = "yes"])
-
-AS_IF([test "x${host_cpu}" = "xarm"], [
-  VLC_FEATURE_DEFAULT_ENABLE([neon])
-], [
-  VLC_FEATURE_DEFAULT_DISABLE([neon])
-])
+VLC_CHECK_MMX()
+VLC_CHECK_SSE()
+VLC_CHECK_3DNOW()
+VLC_CHECK_NEON()
+VLC_CHECK_ALTIVEC()
 
-VLC_FEATURE_OPTION([neon], [enable NEON optimizations], [auto])
-AS_IF([VLC_FEATURE_ENABLED([neon])], [
-  AC_CACHE_CHECK([if $CC groks NEON inline assembly], [ac_cv_neon_inline], [
-    CFLAGS="${CFLAGS_save} -mfpu=neon"
-    AC_COMPILE_IFELSE([
-      AC_LANG_PROGRAM(,[[asm volatile("vqmovun.s64 d0, q1":::"d0");]])
-    ], [
-      ac_cv_neon_inline="-mfpu=neon"
-    ], [
-      ac_cv_neon_inline="no"
+dnl Actions based on enabled optimizations
+AS_IF([test "x${SYS}" = "xdarwin"], [
+  AS_IF([VLC_FEATURE_ENABLED([altivec])], [
+    AC_CACHE_CHECK([if linker needs -framework vecLib], [ac_cv_ld_altivec], [
+      LDFLAGS="${LDFLAGS_vlc} -Wl,-framework,vecLib"
+      AC_LINK_IFELSE([AC_LANG_PROGRAM()], [ac_cv_ld_altivec="yes"],
+                     [ac_cv_ld_altivec="no"])
+      LDFLAGS="${LDFLAGS_vlc}"
     ])
-    CFLAGS="${CFLAGS_save}"
-  ])
-  ARM_NEON_CFLAGS="$ac_cv_neon_inline"
-], [
-  ac_cv_neon_inline="no"
-])
-AC_SUBST(ARM_NEON_CFLAGS)
-AM_CONDITIONAL(HAVE_ARM_NEON, [test "${ac_cv_neon_inline}" != "no"])
 
-AS_IF([test "x${host_cpu}" = "xpowerpc"], [
-  VLC_FEATURE_DEFAULT_ENABLE([altivec])
-], [
-  VLC_FEATURE_DEFAULT_DISABLE([altivec])
-])
-VLC_FEATURE_OPTION([altivec], [enable AltiVec optimizations], [auto])
-have_altivec="no"
-AS_IF([VLC_FEATURE_ENABLED([altivec])], [
-  ARCH="${ARCH} altivec";
-  AC_CACHE_CHECK([if $CC groks AltiVec inline assembly],
-    [ac_cv_altivec_inline],
-    [CFLAGS="${CFLAGS_save}"
-     AC_TRY_COMPILE(,[asm volatile("vperm 0,1,2,3");],
-         ac_cv_altivec_inline="yes",
-         [CFLAGS="${CFLAGS_save} -Wa,-m7400"
-          AC_TRY_COMPILE(,[asm volatile("vperm 0,1,2,3");],
-            [ac_cv_altivec_inline="-Wa,-m7400"],
-            ac_cv_altivec_inline=no)
-         ])])
-  AS_IF([test "${ac_cv_altivec_inline}" != "no"], [
-    AC_DEFINE(CAN_COMPILE_ALTIVEC, 1,
-              [Define to 1 if AltiVec inline assembly is available.])
-    AS_IF([test "${ac_cv_altivec_inline}" != "yes"], [
-      VLC_ADD_CFLAGS([idctaltivec],[${ac_cv_altivec_inline}])
-      VLC_ADD_CFLAGS([motionaltivec],[${ac_cv_altivec_inline}])
-      VLC_ADD_CFLAGS([memcpyaltivec],[${ac_cv_altivec_inline}])
-      VLC_ADD_CFLAGS([i420_yuy2_altivec],[${ac_cv_altivec_inline}])
-      VLC_ADD_CFLAGS([libvlccore],[${ac_cv_altivec_inline}])
+    AS_IF([test "x${ac_cv_ld_altivec}" = "xyes"], [
+      VLC_ADD_LDFLAGS([libvlccore idctaltivec motionaltivec memcpyaltivec],
+                      [-Wl,-framework,vecLib])
     ])
-    have_altivec="yes"
   ])
+])
 
-dnl The AltiVec C extensions
-dnl
-dnl There are several possible cases:
-dnl - OS X PPC, gcc 4.x: use -mpim-altivec -force_cpusubtype_ALL, don't
-dnl                      need <altivec.h>
-dnl - OS X PPC, gcc 3.x: need -faltivec, don't need <altivec.h>
-dnl - Linux PPC, gcc 3.4, 4.x: need <altivec.h> which requires -maltivec
-dnl - Linux PPC, gcc 3.3: need <altivec.h> and -maltivec -mabi=altivec
-dnl - Linux PPC, gcc 3.x: need <altivec.h> and -fvec
-dnl - Others: test should fail
-  AC_CACHE_CHECK([if \$CC groks AltiVec C extensions],
-  [ac_cv_c_altivec],
-  [# OS X/PPC test (gcc 4.x)
-   CFLAGS="${CFLAGS_save} -mpim-altivec -force_cpusubtype_ALL"
-   AC_TRY_COMPILE([vector unsigned char foo;],
-     [vec_ld(0, (unsigned char *)0);],
-     [ac_cv_c_altivec="-mpim-altivec -force_cpusubtype_ALL"],
-     [# OS X/PPC test (gcc 3.x)
-      CFLAGS="${CFLAGS_save} -faltivec"
-      AC_TRY_COMPILE([vector unsigned char foo;],
-        [vec_ld(1 * sizeof(vector float), (unsigned char *)0);],
-        [ac_cv_c_altivec="-faltivec"],
-        dnl Below this are the Linux tests
-        [# Linux/PPC test (gcc 4.x)
-         CFLAGS="${CFLAGS_save} -maltivec"
-         AC_TRY_COMPILE([#include <altivec.h>],
-           [vec_ld(0, (unsigned char *)0);],
-           [ac_cv_c_altivec="-maltivec"],
-           [# Linux/PPC test (gcc 3.3)
-            CFLAGS="${CFLAGS_save} -maltivec -mabi=altivec"
-            AC_TRY_COMPILE([#include <altivec.h>],
-              [vec_ld(0, (unsigned char *)0);],
-              [ac_cv_c_altivec=""
-               ac_cv_c_altivec_abi="-maltivec -mabi=altivec"],
-              [# Linux/PPC test (gcc 3.3)
-               CFLAGS="${CFLAGS_save} -fvec"
-               AC_TRY_COMPILE([#include <altivec.h>],
-                 [vec_ld(0, (unsigned char *)0);],
-                 [ac_cv_c_altivec="-fvec"],
-                 [ac_cv_c_altivec=no])
-              ])
-           ])
-        ])
-     ])
-   CFLAGS="${CFLAGS_save}"
-  ])
-  AS_IF([test "${ac_cv_c_altivec}" != "no"], [
-    CPPFLAGS="${CPPFLAGS_save} ${ac_cv_c_altivec}"
-  ])
+AS_IF([{ VLC_FEATURE_ENABLED([mmx]) && test "x${ac_cv_c_mmx_intrinsics}" = "xyes"; }], [
+  VLC_ADD_CFLAGS([mmx], [-mmmx])
+])
 
-  AC_CHECK_HEADERS(altivec.h)
-  CPPFLAGS="${CPPFLAGS_save}"
+AS_IF([{ VLC_FEATURE_ENABLED([sse]) && test "x${ac_cv_c_sse2_intrinsics}" = "xyes"; }], [
+  VLC_ADD_CFLAGS([sse2], [-msse2])
+])
 
-  AS_IF([test "${ac_cv_c_altivec}" != "no"], [
-    AC_DEFINE(CAN_COMPILE_C_ALTIVEC, 1,
-              [Define to 1 if C AltiVec extensions are available.])
-    VLC_ADD_CFLAGS([libvlccore],[${ac_cv_c_altivec}])
-    VLC_ADD_CFLAGS([idctaltivec motionaltivec],[${ac_cv_c_altivec}])
-    VLC_ADD_CFLAGS([i420_yuy2_altivec memcpyaltivec deinterlace],[${ac_cv_c_altivec} ${ac_cv_c_altivec_abi}])
-    have_altivec="yes"
+dnl Those vars can be set to yes/no/-flagFoo or it can be left uninitialized.
+dnl If it contains -flagFoo, add the specific CFLAGS.
+AS_IF([VLC_FEATURE_ENABLED([neon])], [
+  AS_CASE(["${ac_cv_neon_inline}"], [""|"yes"|"no"], [], [
+    VLC_ADD_CFLAGS([arm_neon], [${ac_cv_neon_inline}])
   ])
+])
 
-  AC_CACHE_CHECK([if linker needs -framework vecLib],
-    [ac_cv_ld_altivec],
-    [LDFLAGS="${LDFLAGS_vlc} -Wl,-framework,vecLib"
-     AC_TRY_LINK([],,ac_cv_ld_altivec=yes,ac_cv_ld_altivec=no)
-     LDFLAGS="${LDFLAGS_save}"
-    ])
-  AS_IF([test "${ac_cv_ld_altivec}" != "no"], [
-    VLC_ADD_LDFLAGS([libvlccore idctaltivec motionaltivec memcpyaltivec],[-Wl,-framework,vecLib])
-  ])
+AS_CASE(["${ac_cv_altivec_inline}"], [""|"yes"|"no"], [], [
+  VLC_ADD_CFLAGS([idctaltivec motionaltivec memcpyaltivec i420_yuv2_altivec libvlccore],
+                 [${ac_cv_altivec_inline}])
 ])
-AM_CONDITIONAL([HAVE_ALTIVEC], [test "$have_altivec" = "yes"])
+
 
 dnl
 dnl  Special arch tuning
diff --git a/m4/vlc_optimizations.m4 b/m4/vlc_optimizations.m4
new file mode 100644
index 0000000..7dc8ff2
--- /dev/null
+++ b/m4/vlc_optimizations.m4
@@ -0,0 +1,356 @@
+dnl Handling optimizations determined by ./configure like mmx/sse/etc.
+
+
+
+dnl  Check for fully working MMX intrinsics
+dnl  We need support for -mmmx, we need <mmintrin.h>, and we also need a
+dnl  working compiler (http://gcc.gnu.org/bugzilla/show_bug.cgi?id=23963)
+AC_DEFUN([VLC_CHECK_MMX], [
+  VLC_FEATURE_OPTION([mmx], [enable MMX optimizations], [auto])
+
+  AS_IF([VLC_FEATURE_ENABLED([mmx])], [
+    AC_CACHE_CHECK([if $CC groks MMX intrinsics], [ac_cv_c_mmx_intrinsics], [
+      CFLAGS="${CFLAGS_save} -O -mmmx"
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM([[#include <mmintrin.h>
+                          #include <stdint.h>
+                          uint64_t frobzor;]],
+                        [[__m64 a, b, c;
+                          a = b = c = (__m64)frobzor;
+                          a = _mm_slli_pi16(a, 3);
+                          a = _mm_adds_pi16(a, b);
+                          c = _mm_srli_pi16(c, 8);
+                          c = _mm_slli_pi16(c, 3);
+                          b = _mm_adds_pi16(b, c);
+                          a = _mm_unpacklo_pi8(a, b);
+                          frobzor = (uint64_t)a;]])
+      ],
+      [ac_cv_c_mmx_intrinsics="yes"], [ac_cv_c_mmx_intrinsics="no"])
+      CFLAGS="${CFLAGS_save}"
+    ])
+
+    AS_IF([test "x${ac_cv_c_mmx_intrinsics}" = "xyes"], [
+      AC_DEFINE([HAVE_MMX_INTRINSICS], 1,
+                [Define to 1 if MMX intrinsics are available.])
+    ])
+
+    AC_CACHE_CHECK([if $CC groks MMX inline assembly], [ac_cv_mmx_inline], [
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM(,[[void *p;
+                           asm volatile("packuswb %%mm1,%%mm2"::"r"(p));]])
+      ],
+      [ac_cv_mmx_inline="yes"], [ac_cv_mmx_inline="no"])
+    ])
+
+    AS_IF([test "x${ac_cv_mmx_inline}" = "xyes"], [
+      have_mmx="yes"
+      AC_DEFINE([CAN_COMPILE_MMX], 1,
+                [Define to 1 inline MMX assembly is available.])
+    ])
+
+    AC_CACHE_CHECK([if $CC groks MMX EXT inline assembly], [ac_cv_mmxext_inline], [
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM(,[[void *p;
+                           asm volatile("maskmovq %%mm1,%%mm2"::"r"(p));]])
+      ],
+      [ac_cv_mmxext_inline="yes"], [ac_cv_mmxext_inline="no"])
+    ])
+
+    AS_IF([test "x${ac_cv_mmxext_inline}" = "xyes"], [
+      have_mmxext="yes"
+      AC_DEFINE([CAN_COMPILE_MMXEXT], 1,
+                [Define to 1 if MMX EXT inline assembly is available.])
+    ])
+  ])
+
+  AM_CONDITIONAL([HAVE_MMX], [test "x${have_mmx}" = "xyes"])
+  AM_CONDITIONAL([HAVE_MMXEXT], [test "x${have_mmxext}" = "xyes"])
+])
+
+
+
+dnl  Check for fully workin SSE2 intrinsics
+dnl  We need support for -mmmx, we need <emmintrin.h>, and we also need a
+dnl  working compiler (http://gcc.gnu.org/bugzilla/show_bug.cgi?id=23963)
+AC_DEFUN([VLC_CHECK_SSE], [
+  VLC_FEATURE_OPTION([sse], [enable SSE (1, 2, 3 and 4) optimizations], [auto])
+
+  AS_IF([VLC_FEATURE_ENABLED([sse])], [
+    AC_CACHE_CHECK([if $CC groks SSE2 intrinsics], [ac_cv_c_sse2_intrinsics], [
+      CFLAGS="${CFLAGS_save} -O -msse2"
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM([[#include <emmintrin.h>
+                          #include <stdint.h>
+                          uint64_t frobzor;]],
+                        [[__m128i a, b, c;
+                          a = b = c = _mm_set1_epi64((__m64)frobzor);
+                          a = _mm_slli_epi16(a, 3);
+                          a = _mm_adds_epi16(a, b);
+                          c = _mm_srli_epi16(c, 8);
+                          c = _mm_slli_epi16(c, 3);
+                          b = _mm_adds_epi16(b, c);
+                          a = _mm_unpacklo_epi8(a, b);
+                          frobzor = (uint64_t)_mm_movepi64_pi64(a);]])
+      ],
+      [ac_cv_c_sse2_intrinsics=yes], [ac_cv_c_sse2_intrinsics=no])
+      CFLAGS="${CFLAGS_save}"
+    ])
+
+    AS_IF([test "x${ac_cv_c_sse2_intrinsics}" = "xyes"], [
+      AC_DEFINE([HAVE_SSE2_INTRINSICS], 1,
+                [Define to 1 if SSE2 intrinsics are available.])
+    ])
+
+    # SSE1
+    AC_CACHE_CHECK([if $CC groks SSE inline assembly], [ac_cv_sse_inline], [
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM(,[[void *p;
+                           asm volatile("xorps %%xmm1,%%xmm2"::"r"(p));]])
+      ],
+      [ac_cv_sse_inline="yes"], [ac_cv_sse_inline="no"])
+    ])
+
+    # SSE2
+    AS_IF([test "x${ac_cv_sse_inline}" = "xyes"], [
+      AC_DEFINE([CAN_COMPILE_SSE], 1,
+                [Define to 1 if SSE inline assembly is available.])
+    ])
+
+    AC_CACHE_CHECK([if $CC groks SSE2 inline assembly], [ac_cv_sse2_inline], [
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM(,[[void *p;
+                         asm volatile("punpckhqdq %%xmm1,%%xmm2"::"r"(p));]])
+      ],
+      [ac_cv_sse2_inline="yes"], [ac_cv_sse2_inline="no"])
+    ])
+
+    AS_IF([test "x${ac_cv_sse2_inline}" = "xyes"], [
+      have_sse2="yes"
+      AC_DEFINE([CAN_COMPILE_SSE2], 1,
+                [Define to 1 if SSE2 inline assembly is available.])
+    ])
+
+    # SSE3
+    AC_CACHE_CHECK([if $CC groks SSE3 inline assembly], [ac_cv_sse3_inline], [
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM(,[[void *p;
+                           asm volatile("movsldup %%xmm1,%%xmm0"::"r"(p));]])
+      ],
+      [ac_cv_sse3_inline="yes"], [ac_cv_sse3_inline="no"])
+    ])
+
+    AS_IF([test "x${ac_cv_sse3_inline}" = "xyes"], [
+      AC_DEFINE([CAN_COMPILE_SSE3], 1,
+                [Define to 1 if SSE3 inline assembly is available.])
+    ])
+
+    # SSSE3
+    AC_CACHE_CHECK([if $CC groks SSSE3 inline assembly], [ac_cv_ssse3_inline], [
+      CFLAGS="${CFLAGS_save}"
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM(,[[void *p;
+                           asm volatile("pabsw %%xmm0,%%xmm0"::"r"(p));]])
+      ],
+      [ac_cv_ssse3_inline="yes"], [ac_cv_ssse3_inline="no"])
+    ])
+
+    AS_IF([test "x${ac_cv_ssse3_inline}" = "xyes"], [
+      AC_DEFINE([CAN_COMPILE_SSSE3], 1,
+                [Define to 1 if SSSE3 inline assembly is available.])
+    ])
+
+    # SSE4.1
+    AC_CACHE_CHECK([if $CC groks SSE4.1 inline assembly], [ac_cv_sse4_1_inline], [
+      CFLAGS="${CFLAGS_save}"
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM(,[[void *p;
+                           asm volatile("pmaxsb %%xmm1,%%xmm0"::"r"(p));]])
+      ],
+      [ac_cv_sse4_1_inline="yes", ac_cv_sse4_1_inline="no"])
+    ])
+
+    AS_IF([test "x${ac_cv_sse4_1_inline}" = "xyes"], [
+      AC_DEFINE([CAN_COMPILE_SSE4_1], 1,
+                [Define to 1 if SSE4_1 inline assembly is available.])
+    ])
+
+    # SSE4.2
+    AC_CACHE_CHECK([if $CC groks SSE4.2 inline assembly], [ac_cv_sse4_2_inline], [
+      CFLAGS="${CFLAGS_save}"
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM(,[[void *p;
+                           asm volatile("pcmpgtq %%xmm1,%%xmm0"::"r"(p));]])
+      ],
+      [ac_cv_sse4_2_inline="yes"], [ac_cv_sse4_2_inline="no"])
+    ])
+
+    AS_IF([test "x${ac_cv_sse4_2_inline}" = "xyes"], [
+      AC_DEFINE([CAN_COMPILE_SSE4_2], 1,
+                [Define to 1 if SSE4_2 inline assembly is available.])
+    ])
+
+    # SSE4A
+    AC_CACHE_CHECK([if $CC groks SSE4A inline assembly], [ac_cv_sse4a_inline], [
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM(,[[void *p;
+                           asm volatile("insertq %%xmm1,%%xmm0"::"r"(p));]])
+      ],
+      [ac_cv_sse4a_inline="yes"], [ac_cv_sse4a_inline="no"])
+    ])
+
+    AS_IF([test "x${ac_cv_sse4a_inline}" = "xyes"], [
+      AC_DEFINE([CAN_COMPILE_SSE4A], 1,
+                [Define to 1 if SSE4A inline assembly is available.])
+    ])
+  ])
+
+  AM_CONDITIONAL([HAVE_SSE2], [test "x${have_sse2}" = "xyes"])
+])
+
+
+
+dnl Check for working 3D Now!
+AC_DEFUN([VLC_CHECK_3DNOW], [
+  AC_CACHE_CHECK([if $CC groks 3D Now! inline assembly], [ac_cv_3dnow_inline], [
+    AC_COMPILE_IFELSE([
+      AC_LANG_PROGRAM(,[[void *p;
+                         asm volatile("pfadd %%mm1,%%mm2"::"r"(p));]])
+    ],
+    [ac_cv_3dnow_inline="yes"], [ac_cv_3dnow_inline="no"])
+  ])
+
+  AS_IF([test "x${ac_cv_3dnow_inline}" = "xyes"], [
+    have_3dnow="yes"
+    AC_DEFINE([CAN_COMPILE_3DNOW], 1,
+              [Define to 1 if 3D Now! inline assembly is available.])
+  ])
+
+  AM_CONDITIONAL([HAVE_3DNOW], [test "x${have_3dnow}" = "xyes"])
+])
+
+
+
+dnl Check for working NEON
+AC_DEFUN([VLC_CHECK_NEON], [
+  VLC_FEATURE_OPTION([neon], [enable NEON optimizations], [auto])
+
+  AS_IF([VLC_FEATURE_ENABLED([neon])], [
+    AC_CACHE_CHECK([if $CC groks NEON inline assembly], [ac_cv_neon_inline], [
+      CFLAGS="${CFLAGS_save} -mfpu=neon"
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM(,[[asm volatile("vqmovun.s64 d0, q1":::"d0");]])
+      ],
+      [ac_cv_neon_inline="-mfpu=neon"], [ac_cv_neon_inline="no"])
+      CFLAGS="${CFLAGS_save}"
+    ])
+
+    AS_IF([test "x${ac_cv_neon_inline}" != "xno"], [
+      have_neon="yes"
+    ])
+  ])
+
+  AM_CONDITIONAL([HAVE_ARM_NEON], [test "x${have_neon}" = "xyes"])
+])
+
+
+
+dnl Check for working AltiVec
+AC_DEFUN([VLC_CHECK_ALTIVEC], [
+  VLC_FEATURE_OPTION([altivec], [enable AltiVec optimizations], [auto])
+
+  AS_IF([VLC_FEATURE_ENABLED([altivec])], [
+    AC_CACHE_CHECK([if $CC groks AltiVec inline assembly], [ac_cv_altivec_inline], [
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM(,[[asm volatile("vperm 0,1,2,3");]])
+      ], [ac_cv_altivec_inline="yes"], [
+        CFLAGS="${CFLAGS_save} -Wa,-m7400"
+        AC_COMPILE_IFELSE([
+          AC_LANG_PROGRAM(,[[asm volatile("vperm 0,1,2,3");]])
+        ], [ac_cv_altivec_inline="-Wa,-m7400"], [ac_cv_altivec_inline="no"])
+        CFLAGS="${CFLAGS_save}"
+      ])
+    ])
+
+    AS_IF([test "x${ac_cv_altivec_inline}" != "xno"], [
+      have_altivec="yes"
+      AC_DEFINE([CAN_COMPILE_ALTIVEC], 1,
+                [Define to 1 if AltiVec inline assembly is available.])
+    ])
+
+    dnl The AltiVec C extensions
+    dnl
+    dnl There are several possible cases:
+    dnl - OS X PPC, gcc 4.x: use -mpim-altivec -force_cpusubtype_ALL, don't
+    dnl                      need <altivec.h>
+    dnl - OS X PPC, gcc 3.x: need -faltivec, don't need <altivec.h>
+    dnl - Linux PPC, gcc 3.4, 4.x: need <altivec.h> which requires -maltivec
+    dnl - Linux PPC, gcc 3.3: need <altivec.h> and -maltivec -mabi=altivec
+    dnl - Linux PPC, gcc 3.x: need <altivec.h> and -fvec
+    dnl - Others: test should fail
+
+    AC_CACHE_CHECK([if \$CC groks AltiVec C extensions], [ac_cv_c_altivec], [
+      # OS X/PPC test (gcc 4.x)
+      CFLAGS="${CFLAGS_save} -mpim-altivec -force_cpusubtype_ALL"
+      AC_COMPILE_IFELSE([
+        AC_LANG_PROGRAM([[vector unsigned char foo;]],
+                        [[vec_ld(0, (unsigned char *)0);]])
+      ],
+      [ac_cv_c_altivec="-mpim-altivec -force_cpusubtype_ALL"],
+      [
+        # OS X/PPC test (gcc 3.x)
+        CFLAGS="${CFLAGS_save} -faltivec"
+        AC_COMPILE_IFELSE([
+          AC_LANG_PROGRAM([[vector unsigned char foo;]],
+                          [[vec_ld(1 * sizeof(vector float), (unsigned char *)0);]])
+        ],
+        [ac_cv_c_altivec="-faltivec"],
+        [
+          dnl Below this are the Linux tests
+          # Linux/PPC test (gcc 4.x)
+          CFLAGS="${CFLAGS_save} -maltivec"
+          AC_COMPILE_IFELSE([
+            AC_LANG_PROGRAM([[#include <altivec.h>]],
+                            [[vec_ld(0, (unsigned char *)0);]])
+          ],
+          [ac_cv_c_altivec="-maltivec"],
+          [
+            # Linux/PPC test (gcc 3.3)
+            CFLAGS="${CFLAGS_save} -maltivec -mabi=altivec"
+            AC_COMPILE_IFELSE([
+              AC_LANG_PROGRAM([[#include <altivec.h>]],
+                              [[vec_ld(0, (unsigned char *)0);]])
+            ],
+            [ac_cv_c_altivec="" ac_cv_c_altivec_abi="-maltivec -mabi=altivec"],
+            [
+              # Linux/PPC test (gcc 3.3)
+              CFLAGS="${CFLAGS_save} -fvec"
+              AC_COMPILE_IFELSE([
+                AC_LANG_PROGRAM([[#include <altivec.h>]],
+                                [[vec_ld(0, (unsigned char *)0);]])
+              ],
+              [ac_cv_c_altivec="-fvec"],
+              [ac_cv_c_altivec="no"])
+            ])
+          ])
+        ])
+      ])
+      CFLAGS="${CFLAGS_save}"
+    ])
+
+    AS_IF([test "x${ac_cv_c_altivec}" != "xno"], [
+      CPPFLAGS="${CPPFLAGS_save} ${ac_cv_c_altivec}"
+    ])
+
+    AC_CHECK_HEADERS([altivec.h])
+
+    CPPFLAGS="${CPPFLAGS_save}"
+
+    AS_IF([test "x${ac_cv_c_altivec}" != "xno"], [
+      AC_DEFINE([CAN_COMPILE_C_ALTIVEC], 1,
+                [Define to 1 if C AltiVec extensions are available.])
+      have_altivec="yes"
+    ])
+  ])
+
+  AM_CONDITIONAL([HAVE_ALTIVEC], [test "x${have_altivec}" = "xyes"])
+])
diff --git a/modules/arm_neon/Modules.am b/modules/arm_neon/Modules.am
index 52393b1..ef623c7 100644
--- a/modules/arm_neon/Modules.am
+++ b/modules/arm_neon/Modules.am
@@ -1,5 +1,3 @@
-AM_CFLAGS += $(ARM_NEON_CFLAGS)
-
 libaudio_format_neon_plugin_la_SOURCES = \
 	s32_s16.S \
 	audio_format.c
diff --git a/modules/mmx/Modules.am b/modules/mmx/Modules.am
index b2d4b11..cfbf17d 100644
--- a/modules/mmx/Modules.am
+++ b/modules/mmx/Modules.am
@@ -1,5 +1,3 @@
-AM_CFLAGS += $(MMX_CFLAGS)
-
 libmemcpymmx_plugin_la_SOURCES = memcpy.c fastmemcpy.h
 libmemcpymmx_plugin_la_CFLAGS = $(AM_CFLAGS)
 libmemcpymmx_plugin_la_LIBADD = $(AM_LIBADD)
diff --git a/modules/sse2/Modules.am b/modules/sse2/Modules.am
index 899634b..ac9223f 100644
--- a/modules/sse2/Modules.am
+++ b/modules/sse2/Modules.am
@@ -1,5 +1,3 @@
-AM_CFLAGS += $(SSE2_CFLAGS)
-
 libi420_rgb_sse2_plugin_la_SOURCES = \
         ../video_chroma/i420_rgb.c \
 	../video_chroma/i420_rgb.h \
-- 
1.6.6.1


